package cmdbuild.actions;

import java.util.*;

import cmdbuild.action_forms.FindRelationForm2;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.collection.FilterBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class FindRelationAction2 extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	
	public ActionForward filter(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**FILTER**");
		Enumeration n = request.getParameterNames();
		String className = ((FindRelationForm2)form).getClassName();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		String target = "";
		String value = "";
		String filter = "";
		String f_value="";
		Vector rowIdVector = new Vector();
		Vector filterRelationVector = new Vector(); // contains WHERE conditions of the query
		while (n.hasMoreElements()){
			target = (String)n.nextElement();
			value = request.getParameter(target);
			if (value!=null && !value.trim().equals("") && !value.equals("&nbsp;")){
				value = value.toUpperCase();
				System.out.println("u value="+value);
				filter = "f_"+target;
				f_value = request.getParameter(filter);
				//System.out.println("CardAction filter="+filter+" f_value="+f_value);
				if (f_value!=null && f_value.equals(multilanguage.getMessage("com.equal"))){
					filter = "\""+target+"\"='"+value+"'";
					filterRelationVector.add(filter);
				} else if (f_value!=null && f_value.equals("=")){
						filter = "\""+target+"\"='"+value+"'";
						filterRelationVector.add(filter);
				} else if (f_value!=null && f_value.equals("<")){
					filter = "\""+target+"\"<'"+value+"'";
					filterRelationVector.add(filter);
				} else if (f_value!=null && f_value.equals(">")){
					filter = "\""+target+"\">'"+value+"'";
					filterRelationVector.add(filter);
				} else if (f_value!=null && f_value.equals(multilanguage.getMessage("com.contains"))){
					filter = "UPPER(\""+target+"\") LIKE '%"+value+"%'";
					//filter = "\""+target+"\" LIKE '%"+value+"%'";
					filterRelationVector.add(filter);
				} else if (f_value!=null && f_value.equals(multilanguage.getMessage("com.startswith"))){
					filter = "UPPER(\""+target+"\") LIKE '"+value+"%'";
					//filter = "\""+target+"\" LIKE '"+value+"%'";
					filterRelationVector.add(filter);
				}
			}
		}
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBclass CMDB = new CMDBclass(db);
		rowIdVector = CMDB.selectFilteredCardsId(className,filterRelationVector);
		//System.out.println("In filter_ rowIdVector.size="+rowIdVector.size());
		request.getSession().setAttribute("mode","show");
		// saved in the session, allow showing of subset of cards
		FilterBean filterRelationBean = new FilterBean(className,rowIdVector);
		request.getSession().setAttribute("filterRelationBean",filterRelationBean); 
		((FindRelationForm2)form).setRowIdVector(rowIdVector);
		// going to page 1
		request.getSession().setAttribute("page",1+"");
		((FindRelationForm2)form).reset(mapping,request);
		return mapping.findForward("filter");
	}
	
} // end of class
