package cmdbuild.actions;


import java.sql.SQLException;

import cmdbuild.action_forms.CreateGroupForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBgroup;
import cmdbuild.collection.SecurityBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class CreateGroupAction extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward create(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		SecurityBean sb = new SecurityBean();
		String groupName = ((CreateGroupForm)form).getGroupName();
		//String confirmPassword = ((CreateUserForm)form).getConfirmPassword();
		String administrator = ((CreateGroupForm)form).getAdministrator();
		boolean admin = false;
		if (administrator!=null && administrator.equals("on")){
			admin = true;
		}
		sb.setGroup(groupName);
		sb.setAdministrator(admin);
		// String category = ((CreateTableForm)form).getCategory();
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBgroup GROUP = new CMDBgroup(db);
		boolean ok = false;
		try {
			ok = GROUP.createGroup(sb);
		} catch (SQLException e){
			e.printStackTrace();
		}
		if (ok){
			String close="ok";
			request.getSession().setAttribute("close",close);
			return mapping.findForward("create");
		} else {
			System.out.println("Gruppo non creato");
			return mapping.findForward("error");
		}
	}
} // end of class
