package cmdbuild.actions;

import cmdbuild.collection.AssetBean;

import java.util.Enumeration;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

import cmdbuild.action_forms.ImportPopupForm;
import cmdbuild.wizards.importutils.ImportLine;
import cmdbuild.wizards.importutils.ImportTable;

public class ImportPopupAction extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	
	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**EXECUTE**");
		//Vector fields = ((ImportPopupForm)form).getFields();
		ImportTable it = ((ImportPopupForm)form).getIt();
		Enumeration en = it.getLinesVector().elements();
		ImportLine il = null;
		int nlines = 0;
		int ncolumns = 0;
		Enumeration eni = null;
		AssetBean as = null;
		String rval = "";
		String fieldname = "";
		while (en.hasMoreElements()){
			nlines++;
			il = (ImportLine) en.nextElement();
			eni = il.getLineVector().elements();
			ncolumns = 0;
			while (eni.hasMoreElements()){
				ncolumns++;
				fieldname = "y"+nlines+"x"+ncolumns;
				as = (AssetBean) eni.nextElement();
				rval = request.getParameter(fieldname);
				System.out.println(as.getType()+" request val for field "+fieldname+"="+rval);
				as.setValue(rval);
			}
			//il.doCheck();
		}
		it.doCheck();
		request.getSession().setAttribute("importTable",it);
		String close="ok";
		request.getSession().setAttribute("close",close);
		return mapping.findForward("success");
	}
	
} // end of class
