package cmdbuild.actions;


import cmdbuild.action_forms.ModifyDomainForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBmap;
import cmdbuild.collection.DomainBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class ModifyDomainAction extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward modify(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("MDA**MODIFY**");
		String newname = ((ModifyDomainForm)form).getName(); // newname
		String oldname = ((ModifyDomainForm)form).getDomain(); // oldname
		System.out.println("oldname="+oldname+" newname="+newname);
		String directDescription = ((ModifyDomainForm)form).getDirectDescription();
		String inverseDescription = ((ModifyDomainForm)form).getInverseDescription();
		String startClass = ((ModifyDomainForm)form).getStartClass();
		String endClass = ((ModifyDomainForm)form).getEndClass();
		String cardin = ((ModifyDomainForm)form).getCard1()+":"+((ModifyDomainForm)form).getCard2();
		String status = ((ModifyDomainForm)form).getStatus();
		System.out.println("modifydomain("+oldname+","+newname+","+startClass+","+endClass+","+directDescription+","+inverseDescription+","+status+")");
		DomainBean bean = new DomainBean();
		bean.setName(oldname);
		bean.setDirectDescription(directDescription);
		bean.setInverseDescription(inverseDescription);
		bean.setStartClass(startClass);
		bean.setEndClass(endClass);
		bean.setCardinality(cardin);
		bean.setStatus(status);
		// String category = ((CreateTableForm)form).getCategory();
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBmap MAP = new CMDBmap(db);
		boolean ok = MAP.modifyDomain(newname,bean);
		if (ok){
			System.out.println("Dominio modificato " + newname);
			request.getSession().setAttribute("close","ok");
			return mapping.findForward("modify");
		} else {
			System.out.println("Dominio non modificato");
			return mapping.findForward("error");
		}
	}
} // end of class
