<%@ page contentType="text/html; charset=Cp1252" %>
<%@ taglib uri="/tags/struts-bean" prefix="bean" %>
<%@ taglib uri="/tags/struts-html" prefix="html" %>

<%@page import="cmdbuild.db.*"%>
<%@page import="cmdbuild.collection.ClassBean"%>
<%@page import="cmdbuild.action_forms.*" %>
<%@page import="cmdbuild.utils.SecurityDescriptor"%>

<%@ page session="true" %>
<% 
SecurityDescriptor user = null;
if (request.getSession().getAttribute("user")!=null){
	user = (SecurityDescriptor)request.getSession().getAttribute("user");
}
if ( (request.getSession().getAttribute("logged")==null) || (request.getSession().getAttribute("logged")=="false")){
%>
	<jsp:forward page="index.jsp">
		<jsp:param name="" value=""/>
	</jsp:forward>	
<%
}
if ( user!=null && !user.isAdministrator()){
%>
	<jsp:forward page="index.jsp">
		<jsp:param name="" value=""/>
	</jsp:forward>	
<%
}
%>

<% 
String classname;
if (request.getParameter("class") != null){
	classname = request.getParameter("class");
	request.getSession().setAttribute("class",classname);
} else if (request.getSession().getAttribute("class") != null ){
	classname = (String)request.getSession().getAttribute("class");
	request.getSession().setAttribute("class",classname);
} else {
	classname="";
}
String close="";
if (request.getSession().getAttribute("close") != null){
	close = (String)request.getSession().getAttribute("close");
	request.getSession().removeAttribute("close");
}
%>

<html:html locale="true">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=Cp1252"/>
		<title></title>
		<style type="text/css" media="all"> @import "style/popup.css"; </style>
		<script type="text/javascript">
		function closeW(){
			window.opener.document.attributeForm.method.value="del";
			// window.opener.location.href=window.opener.location.href;
			opener.location.href="attribute.jsp?class=<%= classname%>";
			window.close();
		}
		</script>
	</head>
	<%if (close.equals("ok")){ %>
	<body onload="closeW()">
	<%} else {%>
	<body>
	<%} %>
	<div align="center">	
	<div id="area">
		<bean:message key="createattribute.title"/> <%= classname%>
		<div id="container">
			<html:form method="POST" action="createAttribute">
			<table cellpadding="5" cellspacing="0">
				<html:hidden property="method"/>
				<html:hidden property="className"/>
				<html:hidden property="ADefaultLookup"/>
				<% 
					CreateAttributeForm form = (CreateAttributeForm) request.getAttribute("createAttributeForm");
					form.setClassName(classname);
					boolean dis = true;
					String extraInputComment="";
					if (form.getAType().equals("numeric")){ 
						extraInputComment = "precision p.q";
						dis = false;
					} else if (form.getAType().equals("varchar")) {
						extraInputComment = "length";
						dis = false;
					}
				%>
				<tr><td><bean:message key="com.name"/></td><td><html:text property="AName"></html:text></td></tr>
				<tr><td><bean:message key="com.description"/></td><td><html:text property="ADescription"></html:text></td></tr>
				<tr>
				    <td><bean:message key="com.type"/></td>
				    <td>
				       	<select name="AType"  onchange="method.value='addType';submit()">
				        <option value="bool" <%if (form.getAType().equals("bool")) { out.print("selected");} %>>Boolean
						<option value="date" <%if (form.getAType().equals("date")) { out.print("selected");} %>>Date
						<option value="numeric" <%if (form.getAType().equals("numeric")) { out.print("selected");} %>>Decimal
						<option value="float8" <%if (form.getAType().equals("float8")) { out.print("selected");} %>>Double
						<option value="int4" <%if (form.getAType().equals("int4")) { out.print("selected");} %>>Integer
						<option value="lookup" <%if (form.getAType().equals("lookup")) { out.print("selected");} %>>LookUp
						<option value="varchar" <%if (form.getAType().equals("varchar")) { out.print("selected");} %>>String
						<option value="text" <%if (form.getAType().equals("text")) { out.print("selected");} %>>Text
						<option value="timestamp" <%if (form.getAType().equals("timestamp")) { out.print("selected");} %>>Timestamp
						</select>
				    </td>
				</tr>
				<% if (!dis) {%>
				<tr><td><%= extraInputComment%></td><td><html:text property="extraInput"></html:text></td></tr>
				<%} else {%>
				<tr style="display:none"><td><%= extraInputComment%></td><td><html:text property="extraInput"></html:text></td></tr>
				<%} %>
				<% if (form.getAType().equals("lookup")) {%>
				<tr>
				    <td><bean:message key="com.lookup"/></td>
				    <td><html:select property="ALookup" onchange="method.value='loadDefaultLookup';submit()">
					<html:optionsCollection property="lookupType" value="type" label="type"/>
					</html:select></td>
				</tr>
				<%} else {%>
				<tr style="display:none">
				    <td><bean:message key="com.lookup"/></td>
				    <td><html:select property="ALookup">
					<html:optionsCollection property="lookupType" value="type" label="type"/>
					</html:select></td>
				</tr>
				<%} %>
				<tr>
				    <td><bean:message key="com.mandatory"/></td>
				    <td><% if (form.getAMandatory().equals("Y")) {%> 
					       	<select name="AMandatory"  onchange="method.value='addDefault';submit()">
					        <option value="Y" selected>si</option>
							<option value="N">no</option>
							</select>
				    	<%} else {%>
					       	<select name="AMandatory"  onchange="method.value='addDefault';submit()">
				    	    <option value="Y">si</option>
							<option value="N" selected>no</option>
							</select>
				    	<%} %>
				    </td>
				</tr>
				<% if (form.getAMandatory().equals("Y") && !form.getAType().equals("lookup")) { // if mandatory%>
				<tr><td><bean:message key="com.default"/></td><td><html:text property="ADefault"></html:text></td></tr>
				<%} else if (form.getAMandatory().equals("Y") && form.getAType().equals("lookup")) { // if mandatory lookup%>
				<tr><td><bean:message key="com.default"/></td><td><html:text property="ADefault" readonly="true"></html:text></td></tr>								
				<%} else {%>
				<tr style="display:none"><td><bean:message key="com.default"/></td><td><html:text property="ADefault"></html:text></td></tr>
				<%} %>
				<tr><td><bean:message key="com.basedsp"/></td><td><input type="checkbox" name="baseDSP"></td></tr>
				<tr>
				    <td><bean:message key="com.status"/></td>
				    <td>
				       	<select name="AStatus">
				        <option value="active"><bean:message key="com.active"/></option>
						<option value="noactive"><bean:message key="com.noactive"/></option>
						</select>
				    </td>
				</tr>
				<tr><td><input type="button" name="button" value="<bean:message key="com.confirm"/>" onclick="method.value='create';submit();" class="button"></td>
				<td><input type="button" name="button" value="<bean:message key="com.cancel"/>" onclick="window.close();" class="button"></tr>
			</table>
			</html:form>
			<html:errors/>
		</div>
	</div>
	</div> <!-- fine del center -->
	</body>
</html:html>